package com.kingdee.eas.custom.performancenew.handler;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.eas.custom.performancenew.*;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.util.app.ContextUtil;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.web.handler.EditHandler;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author qingwu
 * @date 2024/4/11
 * @apiNote ڼ 
 */
public class ExamineScorerEditHandler extends EditHandler {
    private Context ctx = SHRContext.getInstance().getContext();

    /**
     * ȡֵ   ༭ ʾǰ¼
     *
     * @param request
     * @param modelID id
     * @return
     * @throws SHRWebException
     */
    @Override
    protected CoreBaseInfo getValue(HttpServletRequest request, String modelID) throws SHRWebException {
        ExamineGradePersonInfo examineGradePersonInfo = (ExamineGradePersonInfo) super.getValue(request, modelID);
        ExamineGradePersonEntryCollection entrys = examineGradePersonInfo.getEntrys();
        //ǰ¼Աid
        String currentPersonId = ContextUtil.getCurrentUserInfo(ctx).getPerson().getId().toString();
        for (int i = entrys.size() - 1; i >= 0; i--) {
            ExamineGradePersonEntryInfo examineGradePersonEntryInfo = entrys.get(i);
            //id
            String scorerId = examineGradePersonEntryInfo.getScorer().getId().toString();
            if (!currentPersonId.equals(scorerId)) {
                entrys.remove(examineGradePersonEntryInfo);
            }
        }
        return examineGradePersonInfo;
    }
    //

    /**
     *  ҳ治Ҫ ֻ޸
     *
     * @param request
     * @param response
     * @param modelMap
     * @return
     * @throws SHRWebException
     */
    @Override
    public String saveAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {
        ExamineGradePersonInfo model = (ExamineGradePersonInfo) request.getAttribute("dynamic_model");
        try {
            ExamineGradePersonEntryCollection entrys = model.getEntrys();
            IExamineGradePersonEntry iExamineGradePersonEntry = ExamineGradePersonEntryFactory.getLocalInstance(ctx);
            for (int i = 0; i < entrys.size(); i++) {
                ExamineGradePersonEntryInfo examineGradePersonEntryInfo = entrys.get(i);
                iExamineGradePersonEntry.update(new ObjectUuidPK(examineGradePersonEntryInfo.getId().toString()), examineGradePersonEntryInfo);
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException(e);
        }
        return null;
    }
}
