package com.kingdee.eas.custom.performancenew.handler;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.metadata.entity.FilterInfo;
import com.kingdee.bos.metadata.entity.FilterItemInfo;
import com.kingdee.bos.sql.ParserException;
import com.kingdee.eas.custom.performancenew.ExamineGradePersonEntryCollection;
import com.kingdee.eas.custom.performancenew.ExamineGradePersonEntryInfo;
import com.kingdee.eas.custom.performancenew.ExamineGradePersonInfo;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.util.app.ContextUtil;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.web.handler.EditHandler;
import com.kingdee.shr.base.syssetting.web.json.JSONUtils;
import com.kingdee.shr.batchAffair.web.handler.EmpBatchEnrollListHandler;
import com.kingdee.util.StringUtils;

import javax.servlet.http.HttpServletRequest;
import java.util.Date;
import java.util.Map;

/**
 * @author qingwu
 * @date 2024/4/10
 * @apiNote 绩效管理  组织绩效得分
 * EmpBatchEnrollListHandler
 */
public class PerformEditHandler extends EditHandler {

    private Context ctx = SHRContext.getInstance().getContext();

    /**
     * 获取值  表单 编辑表格 过滤显示当前登录人数据
     *
     * @param request
     * @param modelID 单据id
     * @return
     * @throws SHRWebException
     */
    @Override
    protected CoreBaseInfo getValue(HttpServletRequest request, String modelID) throws SHRWebException {
        ExamineGradePersonInfo examineGradePersonInfo = (ExamineGradePersonInfo) super.getValue(request, modelID);
        ExamineGradePersonEntryCollection entrys = examineGradePersonInfo.getEntrys();
        //当前登录员工id
        String currentPersonId = ContextUtil.getCurrentUserInfo(ctx).getPerson().getId().toString();
        for (int i = entrys.size() - 1; i >= 0; i--) {
            ExamineGradePersonEntryInfo examineGradePersonEntryInfo = entrys.get(i);
            //评分人id
            String scorerId = examineGradePersonEntryInfo.getScorer().getId().toString();
            if (!currentPersonId.equals(scorerId)) {
                entrys.remove(examineGradePersonEntryInfo);
            }
        }
        return examineGradePersonInfo;
    }

}
